/* Problem URL: https://codeforces.com/contest/1006/problem/F */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    ll k;
    cin >> n >> m >> k;


    vvl fds(n, vl(m));
    cin >> fds;
    int mid = n / 2;

    if (n == 1) {
        ll ans = 0;
        repv(i, fds[0]) {
            ans ^= i;
        }

        cout << (ans == k) << '\n';
        return 0;
    }

    vvl ans1(m);

    function<void(int, int, ll)> calc1 = [&](int i, int j, ll now) {
        if (i >= n - mid - 1) {
            ans1[j].push_back(now);
        }

        if (j < m - 1) {
            calc1(i, j + 1, now ^ fds[i][j + 1]);
        }
        if (i < n - mid - 1) {
            calc1(i + 1, j, now ^ fds[i + 1][j]);
        }
    };

    calc1(0, 0, fds[0][0]);
    rep(j, m) {
        sortv(ans1[j]);
    }

    ll ans = 0;

    function<void(int, int, ll, int)> calc2 = [&](int i, int j, ll now, int t) {
        if (i == n - 1 && j == m - 1) {
            auto lower = lower_bound(all(ans1[t]), k ^ now);
            auto upper = upper_bound(all(ans1[t]), k ^ now);
            ans += upper - lower;
            return;
        }

        if (i < n - 1) {
            calc2(i + 1, j, now ^ fds[i + 1][j], t);
        }

        if (j < m - 1) {
            calc2(i, j + 1, now ^ fds[i][j + 1], t);
        }
    };

    rep(j, m) {
        calc2(n - mid, j, fds[n - mid][j], j);
    }

    cout << ans << '\n';
}
